<template>
  <q-page class="row justify-center content-start bg-blue-grey-1 q-pa-xl">
    <div class="row justify-between col-12 q-pb-lg">
      <div
        class="text-h4 text-bold text-accent self-end"
        v-text="'Minhas Redações'"
      />

      <q-btn
        class="super-rounded-borders"
        style="width: 272px"
        label="Nova Redação"
        color="primary"
        padding="14px"
        @click="composition"
      />
    </div>

    <table-view
      class="col-12"
      :columns="columns"
      :table-data="tableData"
      sort-by="updatedAt"
    />
  </q-page>
</template>

<script>
import TableView from '../../components/composing/table-view'
import { formatToDate } from 'brazilian-values'

export default {
  name: 'PageCompositions',
  components: { TableView },
  asyncData: {
    tableDataDefault: [],
    async tableData () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Compositions',
          params: {
            filter: {
              where: {
                usuariosId: this.$store.state.session.user.id
              },
              include: {
                relation: 'topic',
                scope: {
                  fields: ['name']
                }
              }
            }
          }
        }

        return this.$axios(axiosConfig)
          .then(R => R.data)
          .finally(() => this.$q.loading.hide())
      } catch (err) {
        this.axiosCatch(err)
      }

      return undefined
    }
  },
  data () {
    return {
      columns: [
        { name: 'id', field: 'id', label: '#', align: 'left', sortable: true },
        { name: 'topic', field: 'topic', label: 'Tema', align: 'left', sortable: true, format: (val, row) => val ? val.name : row.topicId },
        { name: 'title', field: 'title', label: 'Título', align: 'left', sortable: true },
        { name: 'createdAt', field: 'createdAt', label: 'Data de Envio', align: 'left', sortable: true, format: (val) => this.formatDate(val) },
        { name: 'status', field: 'status', label: 'Status', align: 'left', sortable: true },
        { name: 'action', field: 'action', label: 'Visualizar', align: 'center' }
      ]
    }
  },
  mounted () {
    this.$emit('topic', null)
  },
  methods: {
    formatDate (value) {
      try {
        return formatToDate(new Date(value))
      } catch (e) {
        return value
      }
    },
    composition () {
      const { avaliableWriting } = this.$store.state.session.user

      if (avaliableWriting && avaliableWriting.hasAvaliable) {
        this.$router.push('/composing/0')

        return undefined
      }

      this.$q.dialog({
        title: 'Redação',
        message: 'Você excedeu o envio mensal de redações!',
        persistent: true
      })
    }
  }
}
</script>
